Index: uspace/srv/hid/remcons/user.c
===================================================================
--- uspace/srv/hid/remcons/user.c	(revision b7068da1c1b0f9346acb0d25e3778e57ce5a5e28)
+++ uspace/srv/hid/remcons/user.c	(revision b7068da1c1b0f9346acb0d25e3778e57ce5a5e28)
@@ -0,0 +1,408 @@
+/*
+ * Copyright (c) 2012 Vojtech Horky
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup remcons
+ * @{
+ */
+/** @file
+ */
+#include <async.h>
+#include <stdio.h>
+#include <adt/prodcons.h>
+#include <ipc/input.h>
+#include <ipc/console.h>
+#include <ipc/vfs.h>
+#include <errno.h>
+#include <str_error.h>
+#include <loc.h>
+#include <event.h>
+#include <io/keycode.h>
+#include <align.h>
+#include <malloc.h>
+#include <as.h>
+#include <fibril_synch.h>
+#include <task.h>
+#include <net/in.h>
+#include <net/inet.h>
+#include <net/socket.h>
+#include <io/console.h>
+#include <inttypes.h>
+#include <assert.h>
+#include "user.h"
+#include "telnet.h"
+
+static FIBRIL_MUTEX_INITIALIZE(users_guard);
+static LIST_INITIALIZE(users);
+
+/** Create new telnet user.
+ *
+ * @param socket Socket the user communicates through.
+ * @return New telnet user or NULL when out of memory.
+ */
+telnet_user_t *telnet_user_create(int socket)
+{
+	static int telnet_user_id_counter = 0;
+
+	telnet_user_t *user = malloc(sizeof(telnet_user_t));
+	if (user == NULL) {
+		return NULL;
+	}
+
+	user->id = ++telnet_user_id_counter;
+
+	int rc = asprintf(&user->service_name, "%s/telnet%d", NAMESPACE, user->id);
+	if (rc < 0) {
+		free(user);
+		return NULL;
+	}
+
+	user->socket = socket;
+	user->service_id = (service_id_t) -1;
+	prodcons_initialize(&user->in_events);
+	link_initialize(&user->link);
+	user->socket_buffer_len = 0;
+	user->socket_buffer_pos = 0;
+
+	fibril_condvar_initialize(&user->refcount_cv);
+	fibril_mutex_initialize(&user->guard);
+	user->task_finished = false;
+	user->socket_closed = false;
+	user->locsrv_connection_count = 0;
+
+
+	fibril_mutex_lock(&users_guard);
+	list_append(&user->link, &users);
+	fibril_mutex_unlock(&users_guard);
+
+	user->cursor_x = 0;
+
+	return user;
+}
+
+/** Destroy telnet user structure.
+ *
+ * @param user User to be destroyed.
+ */
+void telnet_user_destroy(telnet_user_t *user)
+{
+	assert(user);
+
+	fibril_mutex_lock(&users_guard);
+	list_remove(&user->link);
+	fibril_mutex_unlock(&users_guard);
+
+	free(user);
+}
+
+/** Find user by service id and increments reference counter.
+ *
+ * @param id Location service id of the telnet user's terminal.
+ */
+telnet_user_t *telnet_user_get_for_client_connection(service_id_t id)
+{
+	telnet_user_t *user = NULL;
+
+	fibril_mutex_lock(&users_guard);
+	list_foreach(users, link) {
+		telnet_user_t *tmp = list_get_instance(link, telnet_user_t, link);
+		if (tmp->service_id == id) {
+			user = tmp;
+			break;
+		}
+	}
+	if (user == NULL) {
+		fibril_mutex_unlock(&users_guard);
+		return NULL;
+	}
+
+	telnet_user_t *tmp = user;
+	fibril_mutex_lock(&tmp->guard);
+	user->locsrv_connection_count++;
+
+	/*
+	 * Refuse to return user whose task already finished or when
+	 * the socket is already closed().
+	 */
+	if (user->task_finished || user->socket_closed) {
+		user = NULL;
+		user->locsrv_connection_count--;
+	}
+
+	fibril_mutex_unlock(&tmp->guard);
+
+
+	fibril_mutex_unlock(&users_guard);
+
+	return user;
+}
+
+/** Notify that client disconnected from the remote terminal.
+ *
+ * @param user To which user the client was connected.
+ */
+void telnet_user_notify_client_disconnected(telnet_user_t *user)
+{
+	fibril_mutex_lock(&user->guard);
+	assert(user->locsrv_connection_count > 0);
+	user->locsrv_connection_count--;
+	fibril_condvar_signal(&user->refcount_cv);
+	fibril_mutex_unlock(&user->guard);
+}
+
+/** Tell whether the launched task already exited and socket is already closed.
+ *
+ * @param user Telnet user in question.
+ */
+bool telnet_user_is_zombie(telnet_user_t *user)
+{
+	fibril_mutex_lock(&user->guard);
+	bool zombie = user->socket_closed || user->task_finished;
+	fibril_mutex_unlock(&user->guard);
+
+	return zombie;
+}
+
+/** Receive next byte from a socket (use buffering.
+ * We need to return the value via extra argument because the read byte
+ * might be negative.
+ */
+static int telnet_user_recv_next_byte_no_lock(telnet_user_t *user, char *byte)
+{
+	/* No more buffered data? */
+	if (user->socket_buffer_len <= user->socket_buffer_pos) {
+		int recv_length = recv(user->socket, user->socket_buffer, BUFFER_SIZE, 0);
+		if ((recv_length == 0) || (recv_length == ENOTCONN)) {
+			user->socket_closed = true;
+			return ENOENT;
+		}
+		if (recv_length < 0) {
+			return recv_length;
+		}
+		user->socket_buffer_len = recv_length;
+		user->socket_buffer_pos = 0;
+	}
+
+	*byte = user->socket_buffer[user->socket_buffer_pos++];
+
+	return EOK;
+}
+
+/** Creates new keyboard event from given char.
+ *
+ * @param type Event type (press / release).
+ * @param c Pressed character.
+ */
+static kbd_event_t* new_kbd_event(kbd_event_type_t type, wchar_t c) {
+	kbd_event_t *event = malloc(sizeof(kbd_event_t));
+	assert(event);
+
+	link_initialize(&event->link);
+	event->type = type;
+	event->c = c;
+	event->mods = 0;
+
+	switch (c) {
+	case '\n':
+		event->key = KC_ENTER;
+		break;
+	case '\t':
+		event->key = KC_TAB;
+		break;
+	case '\b':
+	case 127: /* This is what Linux telnet sends. */
+		event->key = KC_BACKSPACE;
+		event->c = '\b';
+		break;
+	default:
+		event->key = KC_A;
+		break;
+	}
+
+	return event;
+}
+
+/** Process telnet command (currently only print to screen).
+ *
+ * @param user Telnet user structure.
+ * @param option_code Command option code.
+ * @param cmd Telnet command.
+ */
+static void process_telnet_command(telnet_user_t *user,
+    telnet_cmd_t option_code, telnet_cmd_t cmd)
+{
+	if (option_code != 0) {
+		telnet_user_log(user, "Ignoring telnet command %u %u %u.",
+		    TELNET_IAC, option_code, cmd);
+	} else {
+		telnet_user_log(user, "Ignoring telnet command %u %u.",
+		    TELNET_IAC, cmd);
+	}
+}
+
+/** Get next keyboard event.
+ *
+ * @param user Telnet user.
+ * @param event Where to store the keyboard event.
+ * @return Error code.
+ */
+int telnet_user_get_next_keyboard_event(telnet_user_t *user, kbd_event_t *event)
+{
+	fibril_mutex_lock(&user->guard);
+	if (list_empty(&user->in_events.list)) {
+		char next_byte = 0;
+		bool inside_telnet_command = false;
+
+		telnet_cmd_t telnet_option_code = 0;
+
+		/* Skip zeros, bail-out on error. */
+		while (next_byte == 0) {
+			int rc = telnet_user_recv_next_byte_no_lock(user, &next_byte);
+			if (rc != EOK) {
+				fibril_mutex_unlock(&user->guard);
+				return rc;
+			}
+			uint8_t byte = (uint8_t) next_byte;
+
+			/* Skip telnet commands. */
+			if (inside_telnet_command) {
+				inside_telnet_command = false;
+				next_byte = 0;
+				if (TELNET_IS_OPTION_CODE(byte)) {
+					telnet_option_code = byte;
+					inside_telnet_command = true;
+				} else {
+					process_telnet_command(user,
+					    telnet_option_code, byte);
+				}
+			}
+			if (byte == TELNET_IAC) {
+				inside_telnet_command = true;
+				next_byte = 0;
+			}
+		}
+
+		/* CR-LF conversions. */
+		if (next_byte == 13) {
+			next_byte = 10;
+		}
+
+		kbd_event_t *down = new_kbd_event(KEY_PRESS, next_byte);
+		kbd_event_t *up = new_kbd_event(KEY_RELEASE, next_byte);
+		assert(down);
+		assert(up);
+		prodcons_produce(&user->in_events, &down->link);
+		prodcons_produce(&user->in_events, &up->link);
+	}
+
+	link_t *link = prodcons_consume(&user->in_events);
+	kbd_event_t *tmp = list_get_instance(link, kbd_event_t, link);
+
+	fibril_mutex_unlock(&user->guard);
+
+	*event = *tmp;
+
+	free(tmp);
+
+	return EOK;
+}
+
+/** Send data (convert them first) to the socket, no locking.
+ *
+ * @param user Telnet user.
+ * @param data Data buffer (not zero terminated).
+ * @param size Size of @p data buffer in bytes.
+ */
+static int telnet_user_send_data_no_lock(telnet_user_t *user, uint8_t *data, size_t size)
+{
+	uint8_t *converted = malloc(3 * size + 1);
+	assert(converted);
+	int converted_size = 0;
+
+	/* Convert new-lines. */
+	for (size_t i = 0; i < size; i++) {
+		if (data[i] == 10) {
+			converted[converted_size++] = 13;
+			converted[converted_size++] = 10;
+			user->cursor_x = 0;
+		} else {
+			converted[converted_size++] = data[i];
+			if (data[i] == '\b') {
+				user->cursor_x--;
+			} else {
+				user->cursor_x++;
+			}
+		}
+	}
+
+
+	int rc = send(user->socket, converted, converted_size, 0);
+	free(converted);
+
+	return rc;
+}
+
+/** Send data (convert them first) to the socket.
+ *
+ * @param user Telnet user.
+ * @param data Data buffer (not zero terminated).
+ * @param size Size of @p data buffer in bytes.
+ */
+int telnet_user_send_data(telnet_user_t *user, uint8_t *data, size_t size)
+{
+	fibril_mutex_lock(&user->guard);
+
+	int rc = telnet_user_send_data_no_lock(user, data, size);
+
+	fibril_mutex_unlock(&user->guard);
+
+	return rc;
+}
+
+/** Update cursor X position.
+ *
+ * This call may result in sending control commands over socket.
+ *
+ * @param user Telnet user.
+ * @param new_x New cursor location.
+ */
+void telnet_user_update_cursor_x(telnet_user_t *user, int new_x)
+{
+	fibril_mutex_lock(&user->guard);
+	if (user->cursor_x - 1 == new_x) {
+		uint8_t data = '\b';
+		/* Ignore errors. */
+		telnet_user_send_data_no_lock(user, &data, 1);
+	}
+	user->cursor_x = new_x;
+	fibril_mutex_unlock(&user->guard);
+
+}
+
+/**
+ * @}
+ */
Index: uspace/srv/hid/remcons/user.h
===================================================================
--- uspace/srv/hid/remcons/user.h	(revision b7068da1c1b0f9346acb0d25e3778e57ce5a5e28)
+++ uspace/srv/hid/remcons/user.h	(revision b7068da1c1b0f9346acb0d25e3778e57ce5a5e28)
@@ -0,0 +1,103 @@
+/*
+ * Copyright (c) 2012 Vojtech Horky
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup remcons
+ * @{
+ */
+/** @file
+ */
+
+#ifndef TELNET_USER_H_
+#define TELNET_USER_H_
+
+#include <fibril_synch.h>
+#include <inttypes.h>
+#include "remcons.h"
+
+#define BUFFER_SIZE 32
+
+/** Representation of a connected (human) user. */
+typedef struct {
+	/** Mutex guarding the whole structure. */
+	fibril_mutex_t guard;
+
+	/** Internal id, used for creating locfs entries. */
+	int id;
+	/** Associated socket. */
+	int socket;
+	/** Location service id assigned to the virtual terminal. */
+	service_id_t service_id;
+	/** Path name of the service. */
+	char *service_name;
+
+	/** Producer-consumer of kbd_event_t. */
+	prodcons_t in_events;
+	link_t link;
+	char socket_buffer[BUFFER_SIZE];
+	size_t socket_buffer_len;
+	size_t socket_buffer_pos;
+
+	/** Task id of the launched application. */
+	task_id_t task_id;
+
+	/* Reference counting. */
+	fibril_condvar_t refcount_cv;
+	bool task_finished;
+	int locsrv_connection_count;
+	bool socket_closed;
+
+	/** X position of the cursor. */
+	int cursor_x;
+} telnet_user_t;
+
+telnet_user_t *telnet_user_create(int socket);
+void telnet_user_destroy(telnet_user_t *user);
+telnet_user_t *telnet_user_get_for_client_connection(service_id_t id);
+bool telnet_user_is_zombie(telnet_user_t *user);
+void telnet_user_notify_client_disconnected(telnet_user_t *user);
+int telnet_user_get_next_keyboard_event(telnet_user_t *user, kbd_event_t *event);
+int telnet_user_send_data(telnet_user_t *user, uint8_t *data, size_t size);
+void telnet_user_update_cursor_x(telnet_user_t *user, int new_x);
+
+/** Print informational message about connected user. */
+#ifdef CONFIG_DEBUG
+#define telnet_user_log(user, fmt, ...) \
+	printf(NAME " [console %d (%d)]: " fmt "\n", user->id, (int) user->service_id, ##__VA_ARGS__)
+#else
+#define telnet_user_log(user, fmt, ...) (void)0
+#endif
+
+/** Print error message associated with connected user. */
+#define telnet_user_error(user, fmt, ...) \
+	fprintf(stderr, NAME " [console %d (%d)]: ERROR: " fmt "\n", user->id, (int) user->service_id, ##__VA_ARGS__)
+
+#endif
+
+/**
+ * @}
+ */
Index: uspace/srv/hid/s3c24xx_ts/s3c24xx_ts.c
===================================================================
--- uspace/srv/hid/s3c24xx_ts/s3c24xx_ts.c	(revision 7cede12cf8e5870c5c2f9432b6e31b54cf385253)
+++ uspace/srv/hid/s3c24xx_ts/s3c24xx_ts.c	(revision b7068da1c1b0f9346acb0d25e3778e57ce5a5e28)
@@ -85,6 +85,7 @@
 
 	printf(NAME ": S3C24xx touchscreen driver\n");
-
-	rc = loc_server_register(NAME, s3c24xx_ts_connection);
+	
+	async_set_client_connection(s3c24xx_ts_connection);
+	rc = loc_server_register(NAME);
 	if (rc < 0) {
 		printf(NAME ": Unable to register driver.\n");
@@ -139,5 +140,5 @@
 
 	async_set_interrupt_received(s3c24xx_ts_irq_handler);
-	register_irq(inr, device_assign_devno(), 0, &ts_irq_code);
+	irq_register(inr, device_assign_devno(), 0, &ts_irq_code);
 
 	s3c24xx_ts_wait_for_int_mode(ts, updn_down);
Index: uspace/srv/hw/bus/cuda_adb/cuda_adb.c
===================================================================
--- uspace/srv/hw/bus/cuda_adb/cuda_adb.c	(revision 7cede12cf8e5870c5c2f9432b6e31b54cf385253)
+++ uspace/srv/hw/bus/cuda_adb/cuda_adb.c	(revision b7068da1c1b0f9346acb0d25e3778e57ce5a5e28)
@@ -154,5 +154,6 @@
 	}
 
-	rc = loc_server_register(NAME, cuda_connection);
+	async_set_client_connection(cuda_connection);
+	rc = loc_server_register(NAME);
 	if (rc < 0) {
 		printf(NAME ": Unable to register server.\n");
@@ -275,5 +276,5 @@
 	cuda_irq_code.cmds[0].addr = (void *) &((cuda_t *) instance->cuda_kernel)->ifr;
 	async_set_interrupt_received(cuda_irq_handler);
-	register_irq(10, device_assign_devno(), 0, &cuda_irq_code);
+	irq_register(10, device_assign_devno(), 0, &cuda_irq_code);
 
 	/* Enable SR interrupt. */
Index: uspace/srv/hw/char/s3c24xx_uart/s3c24xx_uart.c
===================================================================
--- uspace/srv/hw/char/s3c24xx_uart/s3c24xx_uart.c	(revision 7cede12cf8e5870c5c2f9432b6e31b54cf385253)
+++ uspace/srv/hw/char/s3c24xx_uart/s3c24xx_uart.c	(revision b7068da1c1b0f9346acb0d25e3778e57ce5a5e28)
@@ -79,5 +79,6 @@
 	printf(NAME ": S3C24xx on-chip UART driver\n");
 
-	rc = loc_server_register(NAME, s3c24xx_uart_connection);
+	async_set_client_connection(s3c24xx_uart_connection);
+	rc = loc_server_register(NAME);
 	if (rc < 0) {
 		printf(NAME ": Unable to register server.\n");
@@ -194,5 +195,5 @@
 	async_set_interrupt_received(s3c24xx_uart_irq_handler);
 
-	register_irq(inr, device_assign_devno(), 0, &uart_irq_code);
+	irq_register(inr, device_assign_devno(), 0, &uart_irq_code);
 
 	/* Enable FIFO, Tx trigger level: empty, Rx trigger level: 1 byte. */
Index: uspace/srv/hw/irc/obio/obio.c
===================================================================
--- uspace/srv/hw/irc/obio/obio.c	(revision 7cede12cf8e5870c5c2f9432b6e31b54cf385253)
+++ uspace/srv/hw/irc/obio/obio.c	(revision b7068da1c1b0f9346acb0d25e3778e57ce5a5e28)
@@ -124,9 +124,9 @@
 	
 	base_phys = (void *) paddr;
-	base_virt = as_get_mappable_page(OBIO_SIZE);
 	
 	int flags = AS_AREA_READ | AS_AREA_WRITE;
-	int retval = physmem_map(base_phys, (void *) base_virt,
-	    ALIGN_UP(OBIO_SIZE, PAGE_SIZE) >> PAGE_WIDTH, flags);
+	int retval = physmem_map(base_phys,
+	    ALIGN_UP(OBIO_SIZE, PAGE_SIZE) >> PAGE_WIDTH, flags,
+	    (void *) &base_virt);
 	
 	if (retval < 0) {
Index: uspace/srv/loc/loc.c
===================================================================
--- uspace/srv/loc/loc.c	(revision 7cede12cf8e5870c5c2f9432b6e31b54cf385253)
+++ uspace/srv/loc/loc.c	(revision b7068da1c1b0f9346acb0d25e3778e57ce5a5e28)
@@ -56,4 +56,10 @@
 #define NULL_SERVICES  256
 
+/** Callback session */
+typedef struct {
+	link_t cb_sess_list;
+	async_sess_t *sess;
+} cb_sess_t;
+
 LIST_INITIALIZE(services_list);
 LIST_INITIALIZE(namespaces_list);
@@ -86,5 +92,5 @@
 
 static FIBRIL_MUTEX_INITIALIZE(callback_sess_mutex);
-static async_sess_t *callback_sess = NULL;
+static LIST_INITIALIZE(callback_sess_list);
 
 service_id_t loc_create_id(void)
@@ -608,4 +614,5 @@
 	size_t act_size;
 	loc_service_t *svc;
+	char *fqn;
 	
 	if (!async_data_read_receive(&callid, &size)) {
@@ -625,6 +632,14 @@
 	}
 	
-	act_size = str_size(svc->name);
+	if (asprintf(&fqn, "%s/%s", svc->namespace->name, svc->name) < 0) {
+		fibril_mutex_unlock(&services_list_mutex);
+		async_answer_0(callid, ENOMEM);
+		async_answer_0(iid, ENOMEM);
+		return;
+	}
+	
+	act_size = str_size(fqn);
 	if (act_size > size) {
+		free(fqn);
 		fibril_mutex_unlock(&services_list_mutex);
 		async_answer_0(callid, EOVERFLOW);
@@ -633,6 +648,7 @@
 	}
 	
-	sysarg_t retval = async_data_read_finalize(callid, svc->name,
+	sysarg_t retval = async_data_read_finalize(callid, fqn,
 	    min(size, act_size));
+	free(fqn);
 	
 	fibril_mutex_unlock(&services_list_mutex);
@@ -790,7 +806,10 @@
 }
 
-/** Find ID for category specified by name.
- *
- * On success, answer will contain EOK int retval and service ID in arg1.
+/** Create callback connection.
+ *
+ * Create callback connection which will be used to send category change
+ * events.
+ *
+ * On success, answer will contain EOK int retval.
  * On failure, error code will be sent in retval.
  *
@@ -798,5 +817,5 @@
 static void loc_callback_create(ipc_callid_t iid, ipc_call_t *icall)
 {
-	async_sess_t *cb_sess = async_callback_receive(EXCHANGE_SERIALIZE);
+	cb_sess_t *cb_sess = calloc(1, sizeof(cb_sess_t));
 	if (cb_sess == NULL) {
 		async_answer_0(iid, ENOMEM);
@@ -804,12 +823,16 @@
 	}
 	
+	async_sess_t *sess = async_callback_receive(EXCHANGE_SERIALIZE);
+	if (sess == NULL) {
+		free(cb_sess);
+		async_answer_0(iid, ENOMEM);
+		return;
+	}
+	
+	cb_sess->sess = sess;
+	link_initialize(&cb_sess->cb_sess_list);
+	
 	fibril_mutex_lock(&callback_sess_mutex);
-	if (callback_sess != NULL) {
-		fibril_mutex_unlock(&callback_sess_mutex);
-		async_answer_0(iid, EEXIST);
-		return;
-	}
-	
-	callback_sess = cb_sess;
+	list_append(&cb_sess->cb_sess_list, &callback_sess_list);
 	fibril_mutex_unlock(&callback_sess_mutex);
 	
@@ -820,11 +843,15 @@
 {
 	fibril_mutex_lock(&callback_sess_mutex);
-
-	if (callback_sess != NULL) {
-		async_exch_t *exch = async_exchange_begin(callback_sess);
+	
+	list_foreach(callback_sess_list, link) {
+		cb_sess_t *cb_sess;
+		
+		cb_sess = list_get_instance(link, cb_sess_t, cb_sess_list);
+		
+		async_exch_t *exch = async_exchange_begin(cb_sess->sess);
 		async_msg_0(exch, LOC_EVENT_CAT_CHANGE);
 		async_exchange_end(exch);
 	}
-
+	
 	fibril_mutex_unlock(&callback_sess_mutex);
 }
Index: uspace/srv/net/cfg/e1k.nic
===================================================================
--- uspace/srv/net/cfg/e1k.nic	(revision b7068da1c1b0f9346acb0d25e3778e57ce5a5e28)
+++ uspace/srv/net/cfg/e1k.nic	(revision b7068da1c1b0f9346acb0d25e3778e57ce5a5e28)
@@ -0,0 +1,21 @@
+# E1000 configuration
+
+NAME=e1k
+
+HWPATH=devices/\hw\pci0\00:03.0\port0
+NIL=eth
+IL=ip
+
+# 8023_2_LSAP, 8023_2_SNAP
+ETH_MODE=DIX
+ETH_DUMMY=no
+
+IP_CONFIG=static
+IP_ADDR=10.0.2.15
+IP_ROUTING=yes
+IP_NETMASK=255.255.255.240
+IP_BROADCAST=10.0.2.255
+IP_GATEWAY=10.0.2.2
+ARP=arp
+
+MTU=1500
Index: uspace/srv/net/cfg/lo.nic
===================================================================
--- uspace/srv/net/cfg/lo.nic	(revision 7cede12cf8e5870c5c2f9432b6e31b54cf385253)
+++ uspace/srv/net/cfg/lo.nic	(revision b7068da1c1b0f9346acb0d25e3778e57ce5a5e28)
@@ -3,5 +3,5 @@
 NAME=lo
 
-HWPATH=/virt/lo/port0
+HWPATH=devices/\virt\lo\port0
 NIL=nildummy
 IL=ip
Index: uspace/srv/net/cfg/ne2k.nic
===================================================================
--- uspace/srv/net/cfg/ne2k.nic	(revision 7cede12cf8e5870c5c2f9432b6e31b54cf385253)
+++ uspace/srv/net/cfg/ne2k.nic	(revision b7068da1c1b0f9346acb0d25e3778e57ce5a5e28)
@@ -3,5 +3,5 @@
 NAME=ne2k
 
-HWPATH=/hw/pci0/00:01.0/ne2k/port0
+HWPATH=devices/\hw\pci0\00:01.0\ne2k\port0
 NIL=eth
 IL=ip
Index: uspace/srv/net/net/Makefile
===================================================================
--- uspace/srv/net/net/Makefile	(revision 7cede12cf8e5870c5c2f9432b6e31b54cf385253)
+++ uspace/srv/net/net/Makefile	(revision b7068da1c1b0f9346acb0d25e3778e57ce5a5e28)
@@ -31,5 +31,6 @@
 ROOT_PATH = $(USPACE_PREFIX)/..
 LIBS = $(LIBNET_PREFIX)/libnet.a
-EXTRA_CFLAGS = -I$(LIBNET_PREFIX)/include
+EXTRA_CFLAGS = -I$(LIBNET_PREFIX)/include -I$(LIBNIC_PREFIX)/include \
+    -I$(LIBDRV_PREFIX)/include
 
 COMMON_MAKEFILE = $(ROOT_PATH)/Makefile.common
Index: uspace/srv/net/net/net.c
===================================================================
--- uspace/srv/net/net/net.c	(revision 7cede12cf8e5870c5c2f9432b6e31b54cf385253)
+++ uspace/srv/net/net/net.c	(revision b7068da1c1b0f9346acb0d25e3778e57ce5a5e28)
@@ -2,4 +2,5 @@
  * Copyright (c) 2009 Lukas Mejdrech
  * Copyright (c) 2011 Radim Vansa
+ * Copyright (c) 2011 Jiri Svoboda
  * All rights reserved.
  *
@@ -41,5 +42,4 @@
 #include <stdio.h>
 #include <str.h>
-#include <devman.h>
 #include <str_error.h>
 #include <ns.h>
@@ -56,4 +56,7 @@
 #include <adt/measured_strings.h>
 #include <adt/module_map.h>
+#include <fibril_synch.h>
+#include <loc.h>
+#include <nic.h>
 #include <nil_remote.h>
 #include <net_interface.h>
@@ -73,4 +76,7 @@
 GENERIC_CHAR_MAP_IMPLEMENT(measured_strings, measured_string_t);
 DEVICE_MAP_IMPLEMENT(netifs, netif_t);
+LIST_INITIALIZE(netif_list);
+
+static FIBRIL_MUTEX_INITIALIZE(discovery_lock);
 
 /** Add the configured setting to the configuration map.
@@ -287,10 +293,10 @@
  *
  */
-static int init_device(netif_t *netif, devman_handle_t handle)
+static int init_device(netif_t *netif, service_id_t sid)
 {
 	printf("%s: Initializing device '%s'\n", NAME, netif->name);
 	
-	netif->handle = handle;
-	netif->sess = devman_device_connect(EXCHANGE_SERIALIZE, netif->handle,
+	netif->sid = sid;
+	netif->sess = loc_service_connect(EXCHANGE_SERIALIZE, netif->sid,
 	    IPC_FLAG_BLOCKING);
 	if (netif->sess == NULL) {
@@ -337,5 +343,5 @@
 		    strtol((const char *) setting->value, NULL, 10) : 0;
 		rc = nil_device_req(netif->nil->sess, netif->id,
-		    netif->handle, mtu);
+		    netif->sid, mtu);
 		if (rc != EOK) {
 			printf("%s: Unable to start network interface layer\n",
@@ -359,22 +365,35 @@
 		break;
 	default:
+		printf("%s: Unknown service\n", NAME);
 		return ENOENT;
 	}
 	
 	printf("%s: Activating device '%s'\n", NAME, netif->name);
+	list_append(&netif->netif_list, &netif_list);
 	return nic_set_state(netif->sess, NIC_STATE_ACTIVE);
 }
 
-static int net_port_ready(devman_handle_t handle)
-{
-	char hwpath[MAX_PATH_LENGTH];
-	int rc = devman_fun_get_path(handle, hwpath, MAX_PATH_LENGTH);
-	if (rc != EOK)
+static int net_nic_ready(service_id_t sid)
+{
+	int rc;
+	char *hwpath;
+	
+	rc = loc_service_get_name(sid, &hwpath);
+	if (rc != EOK) {
+		printf("%s: Failed getting name of service '%u'\n",
+		    NAME, (unsigned) sid);
 		return EINVAL;
+	}
 	
 	int index = char_map_find(&net_globals.netif_hwpaths,
 	    (uint8_t *) hwpath, 0);
-	if (index == CHAR_MAP_NULL)
+	
+	if (index == CHAR_MAP_NULL) {
+		printf("%s: Service '%s' not found in map.\n", NAME, hwpath);
+		free(hwpath);
 		return ENOENT;
+	}
+	
+	free(hwpath);
 	
 	netif_t *netif = netifs_get_index(&net_globals.netifs, index);
@@ -382,5 +401,5 @@
 		return ENOENT;
 	
-	rc = init_device(netif, handle);
+	rc = init_device(netif, sid);
 	if (rc != EOK)
 		return rc;
@@ -391,21 +410,4 @@
 	
 	netif->il->usage++;
-	
-	return EOK;
-}
-
-static int net_driver_ready_local(devman_handle_t handle)
-{
-	devman_handle_t *funs;
-	size_t count;
-	int rc = devman_dev_get_functions(handle, &funs, &count);
-	if (rc != EOK)
-		return rc;
-	
-	for (size_t i = 0; i < count; i++) {
-		rc = net_port_ready(funs[i]);
-		if (rc != EOK)
-			return rc;
-	}
 	
 	return EOK;
@@ -479,8 +481,4 @@
 		net_free_devices(strings, count);
 		return rc;
-	case NET_NET_DRIVER_READY:
-		rc = net_driver_ready_local(IPC_GET_ARG1(*call));
-		*answer_count = 0;
-		return rc;
 	default:
 		return ENOTSUP;
@@ -528,4 +526,71 @@
 		answer_call(callid, res, &answer, count);
 	}
+}
+
+static int nic_check_new(void)
+{
+	category_id_t nic_cat;
+	service_id_t *svcs;
+	size_t count, i;
+	bool already_known;
+	int rc;
+
+	fibril_mutex_lock(&discovery_lock);
+
+	rc = loc_category_get_id(DEVICE_CATEGORY_NIC, &nic_cat, IPC_FLAG_BLOCKING);
+	if (rc != EOK) {
+		printf("%s: Failed resolving category '%s'.\n", NAME,
+		    DEVICE_CATEGORY_NIC);
+		return ENOENT;
+	}
+
+	rc = loc_category_get_svcs(nic_cat, &svcs, &count);
+	if (rc != EOK) {
+		printf("%s: Failed getting list of NIC devices.\n", NAME);
+		return EIO;
+	}
+
+	for (i = 0; i < count; i++) {
+		already_known = false;
+
+		list_foreach(netif_list, link) {
+			netif_t *netif = list_get_instance(link, netif_t, netif_list);
+			if (netif->sid == svcs[i]) {
+				already_known = true;
+				break;
+			}
+		}
+
+		if (!already_known) {
+			rc = net_nic_ready(svcs[i]);
+			if (rc != EOK) {
+				printf("%s: Failed adding NIC device #%u.\n",
+				    NAME, (unsigned) svcs[i]);
+			}
+		}
+	}
+
+	free(svcs);
+	fibril_mutex_unlock(&discovery_lock);
+	return EOK;
+}
+
+static void cat_change_cb(void)
+{
+	(void) nic_check_new();
+}
+
+static int net_start_nic_discovery(void)
+{
+	int rc;
+
+	rc = loc_register_cat_change_cb(cat_change_cb);
+	if (rc != EOK) {
+		printf("%s: Failed registering callback for device discovery (%d).\n",
+		    NAME, rc);
+		return rc;
+	}
+
+	return nic_check_new();
 }
 
@@ -573,5 +638,5 @@
 				continue;
 			
-			netif->handle = -1;
+			netif->sid = -1;
 			netif->sess = NULL;
 			
@@ -697,4 +762,11 @@
 	}
 	
+	rc = net_start_nic_discovery();
+	if (rc != EOK) {
+		printf("%s: Error starting NIC discovery\n", NAME);
+		pm_destroy();
+		return rc;
+	}
+	
 	task_retval(0);
 	async_manager();
Index: uspace/srv/net/net/net.h
===================================================================
--- uspace/srv/net/net/net.h	(revision 7cede12cf8e5870c5c2f9432b6e31b54cf385253)
+++ uspace/srv/net/net/net.h	(revision b7068da1c1b0f9346acb0d25e3778e57ce5a5e28)
@@ -35,4 +35,5 @@
 #define NET_NET_H_
 
+#include <ipc/loc.h>
 #include <net/device.h>
 #include <adt/char_map.h>
@@ -41,5 +42,4 @@
 #include <adt/module_map.h>
 #include <net/packet.h>
-#include <devman.h>
 
 #define NAME  "net"
@@ -96,9 +96,11 @@
 	
 	/** Serving network interface driver module index. */
-	devman_handle_t handle;  /**< Handle for devman */
-	async_sess_t *sess;      /**< Driver session. */
+	service_id_t sid;    /**< Service ID */
+	async_sess_t *sess;  /**< Driver session. */
 	
 	module_t *nil;  /**< Serving link layer module index. */
 	module_t *il;   /**< Serving internet layer module index. */
+	
+	link_t netif_list;
 } netif_t;
 
Index: uspace/srv/net/net/packet_server.c
===================================================================
--- uspace/srv/net/net/packet_server.c	(revision 7cede12cf8e5870c5c2f9432b6e31b54cf385253)
+++ uspace/srv/net/net/packet_server.c	(revision b7068da1c1b0f9346acb0d25e3778e57ce5a5e28)
@@ -304,15 +304,14 @@
 static int packet_reply(packet_t *packet)
 {
+	if (!packet_is_valid(packet))
+		return EINVAL;
+	
 	ipc_callid_t callid;
 	size_t size;
-
-	if (!packet_is_valid(packet))
-		return EINVAL;
-
 	if (!async_share_in_receive(&callid, &size)) {
 		async_answer_0(callid, EINVAL);
 		return EINVAL;
 	}
-
+	
 	if (size != packet->length) {
 		async_answer_0(callid, ENOMEM);
@@ -375,7 +374,7 @@
 	case NET_PACKET_GET:
 		packet = pm_find(IPC_GET_ID(*call));
-		if (!packet_is_valid(packet)) {
+		if (!packet_is_valid(packet))
 			return ENOENT;
-		}
+		
 		return packet_reply(packet);
 	
